package particles;
import java.awt.Color;

/* Type representing a point in 2D space. */
public class Particle implements Cloneable {
    /* The particle's position in space. Default is (0, 0). */
    public double x = 0, y = 0;

    /* Particle color. Default is black. */
    public Color color = Color.BLACK;

    /* Particle velocity. Default is stationary. */
    public double dx = 0, dy = 0;

    /* Particle lifetime. Default is a very long time. */
    public int lifetime = 123456789;

    /* Particle type. Default is streamer. */
    public ParticleType type = ParticleType.STREAMER;
    
    /* Convenience method for test cases. */
    @Override public Particle clone() {
        try {
            return (Particle) super.clone();
        } catch (CloneNotSupportedException e) {
            // Not possible; we are cloneable.
            throw new RuntimeException("You have witnessed the impossible!");
        }
    }
}
